// compile with -lrt
#include <semaphore.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/shm.h>

#define SHMSIZE  1024

int main(int argc, char **argv)
{
  int i,nloop=10,*ptr;
  sem_t mutex;

    int shmid1;
    int *shm1, *s;

    if ((shmid1 = shmget(IPC_PRIVATE, SHMSIZE, 0666)) < 0) {
        perror("shmget");
        exit(1);
    }
    
   if ((shm1 = shmat(shmid1, NULL, 0)) == (int *) -1) {
        perror("shmat");
        exit(1);
    }

   *shm1 = 0;
    ptr = shm1;

  if( sem_init(&mutex,1,0) < 0)
    {
      perror("semaphore initilization");
      exit(0);
    }
  if (fork() == 0) { /* child process*/
      sem_wait(&mutex);
    for (i = 0; i < nloop; i++) 
      printf("child: %d\n", (*ptr)++);
    shmctl(shmid1, IPC_RMID, (struct shmid_ds *) 0);
    exit(0);
  }
  /* back to parent process */
  for (i = 0; i < nloop; i++)
    printf("parent: %d\n", (*ptr)++);
    sem_post(&mutex);
  exit(0);
}
